//+------------------------------------------------------------------+
//|                                                  4TF HAS Bar.mq4 |
//|                  Modified by Matsu, from #MTF Supertrend Bar.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"
//----
#property indicator_separate_window
#property indicator_minimum 1
#property indicator_maximum 4
#property indicator_buffers 8
//----
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Green
#property indicator_color6 Red
#property indicator_color7 Green
#property indicator_color8 Red
//---- parameters

//---- parameters to be passed to trix
extern int   A_t3_period     = 20;
extern int   B_t3_period_ac  = 35;
extern int    Trixnum_bars             = 750;
extern bool   UseDivergence = true;
extern int    NumberOfDivergenceBars = 500;

extern int BarWidth=0;
extern color BarColorUp=Lime;
extern color BarColorDown=Red;
extern color BarColorInside=Yellow;
extern color TextColor=Orange;
extern color HighLine_Color = FireBrick;
extern int   Line_Style = STYLE_DOT; 
extern int P1_position=1;
extern int P2_position=2;
extern int P3_position=3;
extern int P4_position=4;
#define Prefix "MTFTrixDiv_"


extern bool showlabels=false;
extern bool showlines=false;
extern string note1="when true picks next 2 higher tfs";
extern string note2="when false select your own tfs";
extern string note3="Period types: 0 = slow, 1 = fast";
extern bool autotimeframe=false;
extern string note4="when true picks 2 additional  higher tfs";
//extern bool EnableAlerts=true;
//extern bool SoundAlertOnOptimum = false;
//extern string OptimumSound ="email.wav";


extern int ePeriod1 = 60;
extern int ePeriod2 =30;
extern int ePeriod3 = 15;
extern int ePeriod4 =5;



extern string note5="Gap between the lines of bars";
extern double Gap=0.6; // Gap between the lines of bars
extern string note6="Label verticle shift";
extern   double v_shift=0.5;
extern string note7="Label horizontal shift";
extern int h_shift =15;
extern string note8="Line verticle shift";
extern double line_v_shift=0.75;

extern bool showcomment=false;
extern bool showdivcomment=true;


double dbuf4_up[];
double dbuf4_down[];
double dbuf3_up[];
double dbuf3_down[];
double dbuf2_up[];
double dbuf2_down[];
double dbuf1_up[];
double dbuf1_down[];





string shortname="";
double TrixUp;
double TrixDown;
double dUp;
double dDown;
double  divUp;
double  divDown;
double  divUp1;
double  divDown1;
double  divUp2;
double  divDown2;
int type;
//----
int ArrSize=110;//159;
int UniqueNum=32834;
int Period_1, Period_2, Period_3, Period_4;

datetime t;
string t1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 
   t=TimeLocal( ) ;
   t1=TimeToStr(t,TIME_SECONDS);
   Comment(t," ",t1);
    SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(0,ArrSize);
   SetIndexBuffer(0,dbuf1_up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(1,ArrSize);
   SetIndexBuffer(1,dbuf1_down);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(2,ArrSize);
   SetIndexBuffer(2,dbuf2_up);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(3,ArrSize);
   SetIndexBuffer(3,dbuf2_down);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(4,ArrSize);
   SetIndexBuffer(4,dbuf3_up);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(5,ArrSize);
   SetIndexBuffer(5,dbuf3_down);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW,0,BarWidth,BarColorUp);
   SetIndexArrow(6,ArrSize);
   SetIndexBuffer(6,dbuf4_up);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW,0,BarWidth,BarColorDown);
   SetIndexArrow(7,ArrSize);
   SetIndexBuffer(7,dbuf4_down);
   SetIndexEmptyValue(7,0.0);
   
  
//----
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);
   IndicatorDigits(0);
   getPeriod();
 
  
  
//----
//removed unnecessary external ma variables
//added vadidation for timeframe and method selection
   shortname= t1+"THV MTF Div Histo V5.0.3 ("+Period_1+","+Period_2+","+Period_3+","+Period_4+")";
   IndicatorShortName(shortname);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  
  Comment("");
  DeleteObjects(Prefix);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    
 
 
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- the last counted bar will be recounted
 
   int limit=Bars-counted_bars;
   int i,tf;
   bool optimumAlarm =false;
//-------------------------------1----------------------------------------   
   double dif=Time[0] - Time[1];
   
   drawLine(Prefix + "dline12", 2 , HighLine_Color, Line_Style);
   drawLine(Prefix + "dline13", 2.75, HighLine_Color, Line_Style);
   drawLine(Prefix + "dline14", 3.25, HighLine_Color, Line_Style);
   drawLine(Prefix + "dline15", 4.50, HighLine_Color, Line_Style);
   cleanLabel();
   placeLabels();
   
 
  
  
//-------------------------------2----------------------------------------
   datetime TimeArray_4[], TimeArray_3[], TimeArray_2[], TimeArray_1[];
   ArrayCopySeries(TimeArray_1,MODE_TIME,Symbol(),Period_1);
   ArrayCopySeries(TimeArray_2,MODE_TIME,Symbol(),Period_2);
   ArrayCopySeries(TimeArray_3,MODE_TIME,Symbol(),Period_3);
   ArrayCopySeries(TimeArray_4,MODE_TIME,Symbol(),Period_4);
 
   int  i1=0, i2=0, i3=0, i4=0, yy;
   
  for(i=0, i1=0,  i2=0,  i3=0,  i4=0;i<limit;i++)
     {
      if (Time[i]<TimeArray_1[i1]) i1++;
      if (Time[i]<TimeArray_2[i2]) i2++;
      if (Time[i]<TimeArray_3[i3]) i3++;
      if (Time[i]<TimeArray_4[i4]) i4++;
//----
            for( tf=1; tf<=4; tf++)
              {
               int prd;
               switch(tf)
                 {
                  case 1: prd=Period_1; yy=i1;  break;
                  case 2: prd=Period_2; yy=i2;  break;
                   case 3: prd=Period_3; yy=i3;   break;
                  case 4: prd=Period_4; yy=i4;   break;
                 }
        
                  TrixUp =iCustom(NULL, prd, "THV3 Trix for MTFHisto",4, yy+2);
                  TrixDown =iCustom(NULL, prd, "THV3 Trix for MTFHisto",5, yy+2);
                
               // TrixUp =iCustom(NULL, prd, "THV3 Trix called", 4, yy+2);//bull
              //  TrixDown =iCustom(NULL, prd, "THV3 Trix called", 5, yy+2);//bear 
               
                
                                   switch(tf)
                                       {  
                                         case 1: 
                                          {
                                               dbuf1_down[i]=EMPTY_VALUE;
                                               dbuf1_up[i]=EMPTY_VALUE; 
                                        
                                               if (TrixUp != EMPTY_VALUE)  
                                               {
                                              dbuf1_up[i]=1 + Gap*P1_position;
                                            
                                              
                                               }
                                               
                                               else  if (TrixDown != EMPTY_VALUE)
                                               {
                                              dbuf1_down[i]=1 +Gap*P1_position ; 
                                               
                                              
                                               }
                                              
                                              
                                             
                                                break;
                                          } 
                                          case 2: 
                                          {
                                            dbuf2_down[i]=EMPTY_VALUE;
                                            dbuf2_up[i]=EMPTY_VALUE; 
                                         
                                            if (TrixUp != EMPTY_VALUE)  
                                               {
                                              dbuf2_up[i]=1 +Gap*P2_position;
                                               }
                                               
                                               else  if (TrixDown != EMPTY_VALUE)
                                               {
                                               dbuf2_down[i]=1 +Gap*P2_position ; 
                                               }
                                           
                                            break;
                                         } 
                                         
                                         case 3: 
                                          {
                                           dbuf3_down[i]=EMPTY_VALUE;
                                           dbuf3_up[i]=EMPTY_VALUE; 
                                          
                                            if (TrixUp != EMPTY_VALUE)  
                                               {
                                               dbuf3_up[i]=1 +Gap*P3_position;
                                               }
                                               
                                               else  if (TrixDown != EMPTY_VALUE)
                                               {
                                               dbuf3_down[i]=1 +Gap*P3_position ; 
                                               }
                                               else
                                               {
                                            
                                               }
                                            break;
                                         } 
                                         
                                         case 4: 
                                          {
                                           dbuf4_down[i]=EMPTY_VALUE;
                                            dbuf4_up[i]=EMPTY_VALUE; 
                                           
                                            if (TrixUp != EMPTY_VALUE)  
                                               {
                                               dbuf4_up[i]=1 +Gap*P4_position;
                                               }
                                               
                                               else  if (TrixDown != EMPTY_VALUE)
                                               {
                                               dbuf4_down[i]=1 +Gap*P4_position ; 
                                               }
                                             
                                            break;
                                         } 
                                         
                                       }
                                       
                      
              }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void getPeriod()
  {
  if (autotimeframe)
  {
     
      switch(Period())
        {
          case 1:
            Period_1=1; Period_2=5; Period_3=15; Period_4=30;
            break;
         case 5:
            Period_1=5; Period_2=15; Period_3=30; Period_4=60;
            break;
         case 15:
            Period_1=15; Period_2=30; Period_3=60; Period_4=240;
            break;
         case 30:
            Period_1=30; Period_2=60; Period_3=240; Period_4=1440;
            break;
         case 60:
            Period_1=60; Period_2=240; Period_3=1440; Period_4=10080;
            break;
         case 240:
            Period_1=240; Period_2=1440; Period_3=10080; Period_4=43200;
            break;
         case 1440:
            Period_1=1440; Period_2=10080; Period_3=43200; Period_4=43200;
            break;
         case 10080:
            Period_1=10080; Period_2=43200; Period_3=43200; Period_4=43200;
            break;
         case 43200:
            Period_1=43200; Period_2=43200; Period_3=43200; Period_4=43200;
            break;
        }
      
      
      
   }
   else
   {
      
   string msgText="Invalid timeframe. Please enter a valid timeframe";
       if (validateInput(ePeriod1)==false)
       {
       Alert(msgText);
       }
       else Period_1= ePeriod1;
       
       if (validateInput(ePeriod2)==false)
       {
       Alert(msgText);
       }
       else Period_2= ePeriod2;
       
       if (validateInput(ePeriod3)==false)
       {
       Alert(msgText);
       }
       else Period_3= ePeriod3;
       
       if (validateInput(ePeriod4)==false)
       {
       Alert(msgText);
       }
       else Period_4= ePeriod4;
       
      
    } 
  }
  
  
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string tf2txt(int tf)
  {
   if (tf==PERIOD_M1)    return("M1");
   if (tf==PERIOD_M5)    return("M5");
   if (tf==PERIOD_M15)   return("M15");
   if (tf==PERIOD_M30)   return("M30");
   if (tf==PERIOD_H1)    return("H1");
   if (tf==PERIOD_H4)    return("H4");
   if (tf==PERIOD_D1)    return("D1");
   if (tf==PERIOD_W1)    return("W1");
   if (tf==PERIOD_MN1)   return("MN");
   return("??");
  }
  
 bool validateInput(int theval)
 {
 bool theanswer=false;
      switch(theval)
        {
         case 1:
            theanswer=true;
            break;
         case 5:
           theanswer=true;
           break;
         case 15:
            theanswer=true;
            break;
         case 30:
           theanswer=true;
           break;
           case 1:
            theanswer=true;
            break;
         case 60:
           theanswer=true;
           break;
         case 240:
            theanswer=true;
            break;
         case 1440:
           theanswer=true;
           break;
        
           case 10080:
            theanswer=true;
            break;
         case 43200:
           theanswer=true;
           break;
         
           
          }
          
          return (theanswer);
 }
 
 

 bool placeLabels()
{
  double dif=Time[0] - Time[1];
 int tf;
   if(showlabels==true)
   {
      for( tf=1; tf<=4; tf++)
        {
         string txt="??";
            double gp;
                 
                     switch(tf)
                      {
                       case 1: txt=tf2txt(Period_1);  gp=1 +  Gap*P1_position+v_shift; break;
                       case 2: txt=tf2txt(Period_2);  gp=1 +   Gap*P2_position + v_shift; break;
                       case 3: txt=tf2txt(Period_3);  gp=1 +  Gap*P3_position+v_shift; break;
                       case 4: txt=tf2txt(Period_4);  gp=1 +   Gap*P4_position + v_shift; break;
                      }
                  
                    
      string name=WindowFind(shortname)+"FF_"+UniqueNum+"_"+tf+"_"+txt;
      if (WindowFind(shortname)!=-1)
            { 
               ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*h_shift, gp);
               ObjectSetText(name, txt,8,"Arial", TextColor);    
              }    
      }
      
    }        
 return(0);   
 
}    
int cleanLabel()
{
if(showlabels==true)
{
int i;
   for( i=ObjectsTotal()-1; i>-1; i--)
     {
    
     if (StringFind(ObjectName(i),WindowFind(shortname)+"FF_" +UniqueNum+"_")>=0)  ObjectDelete(ObjectName(i));  
     
    
     }
   return(0);   
 }     
}
 

 

  
  
void drawLine(string name, double price, color Col, int LvlStyle)
{ 

if ( showlines ==true)
{
 if (WindowFind(shortname)!=-1)
 {  
   ObjectDelete(name);        
   ObjectCreate(name, OBJ_HLINE,WindowFind(shortname),Time[0],price);
   ObjectSet(name, OBJPROP_STYLE, LvlStyle);
   ObjectSet(name, OBJPROP_COLOR, Col);        
   ObjectSet(name, OBJPROP_WIDTH,1);
   }
 }  
}

void DeleteObjects(string ObjName)
{
   for (int i=ObjectsTotal()-1; i >= 0; i--) 
   {
     string name = ObjectName(i);
     if (StringFind(name, ObjName) > -1) ObjectDelete(name);
   }
}

//+------------------------------------------------------------------+